import java.lang.*;
import java.util.*;
import java.text.*;

class ReturnGate extends Observable {

	/**
	 *  Manages the coins for this VendingMachine
	 */
	private CoinManager coinManager_;
	public CoinManager coinManager() { return coinManager_; }
	public void coinManager( CoinManager aCoinManager ) { coinManager_ = aCoinManager; }


	ReturnGate() {
	    this.initialize();
	}

	private void initialize() {
	    // VendingMachine hooks up coinManager
	}

	public void releaseCoins() {
        double viewableAmount = this.coinManager().amountDeposited() / 100.0;
        NumberFormat theNF = NumberFormat.getCurrencyInstance();
        String amountString = theNF.format(viewableAmount);
        this.publicize(amountString);
        this.coinManager().coinsHaveBeenReturned();
	}

	public void publicize(String ammount){
	    this.setChanged();
	    this.notifyObservers(ammount);
	}

}
